# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Member(pulumi.CustomResource):
    """
    Provides a resource to manage a GuardDuty member.
    
    ~> **NOTE:** Currently after using this resource, you must manually accept member account invitations before GuardDuty will begin sending cross-account events. More information for how to accomplish this via the AWS Console or API can be found in the [GuardDuty User Guide](https://docs.aws.amazon.com/guardduty/latest/ug/guardduty_accounts.html). Terraform implementation of the member acceptance resource can be tracked in [Github](https://github.com/terraform-providers/terraform-provider-aws/issues/2489).
    """
    def __init__(__self__, __name__, __opts__=None, account_id=None, detector_id=None, disable_email_notification=None, email=None, invitation_message=None, invite=None):
        """Create a Member resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not account_id:
            raise TypeError('Missing required property account_id')
        __props__['accountId'] = account_id

        if not detector_id:
            raise TypeError('Missing required property detector_id')
        __props__['detectorId'] = detector_id

        __props__['disableEmailNotification'] = disable_email_notification

        if not email:
            raise TypeError('Missing required property email')
        __props__['email'] = email

        __props__['invitationMessage'] = invitation_message

        __props__['invite'] = invite

        __props__['relationship_status'] = None

        super(Member, __self__).__init__(
            'aws:glacier/member:Member',
            __name__,
            __props__,
            __opts__)

